QGIS Application - Bug report #11293
Auto update Shows All Layers
2014-09-29 10:46 PM - ramon .

Status: Closed

Priority: High

Assignee:

Category: Map Composer/Printing

Affected QGIS version:2.18.4
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: Yes
Easy fix?: No
Resolution: end of life

Copied to github as #: 19589

Description

- In 2.4 in the print composer, as a default the legend has Auto update on, but only shows layers that are visible on the map window

(2-4AutoUpdateShowsVisibles).

- In master (commit:b044d4d) the print composer, with the default Auto update on the legend shows all layers, regardless of whether

they are visible on the map (AutoUpdateShowsEverything).

- | think that showing layers in the legend that are not on the map is a bug, in this case a regression.

- In master this is further complicated by the Auto label option locking all of the tools, except filter, which means the legend can't be

fixed without turning Auto update off. The filter (I'm getting inconsistent results with this) might reduce the items to what is visible, but still

leaves object headers for layers that are not on the map.

- | suspect that neither of these outcomes are intended.

Question: in the goal of the auto update to provide an auto list of legend items?
If this is the case, then putting the filter on as a default may also be a good idea.

Related issues:

Related to QGIS Application - Bug report # 13575: "Add a Legend" adds ALL the... Closed 2015-10-12
Duplicated by QGIS Application - Feature request # 18579: More intuitive Lege... Closed 2018-03-29
History

#1 - 2014-09-29 11:03 PM - Nyall Dawson
- Assignee set to Martin Dobias

Related to refactoring of legend, so assigning to Martin

#2 - 2014-10-03 10:56 AM - Giovanni Manghi
- Operating System deleted (win7-64bit)
- OS version deleted (2.4, master)

confirmed on the latest master.

#3 - 2014-10-15 12:19 AM - Olivier Monod
- Assignee deleted (Martin Dobias)
#4 - 2014-10-15 01:56 AM - Olivier Monod
- Assignee set to Martin Dobias

#5 - 2014-10-20 01:06 AM - Alessandro Ciali
One further point on this feature: putting Auto Update on by default regardless of the status saved in the project resets all the settings made for the

legends. This is very annoying, because changing from 2.4 to 2.5 (and | guess 2.6) needs to rebuild all the legend saved in previous version.
Could the option "Auto Update" be disabled by default?

#6 - 2014-10-24 04:18 AM - Martin Dobias
- Priority changed from Severe/Regression to High

The second issue (with layer titles being visible with filtering enabled even if the layer is not visible) is now fixed (4ac94f).

The auto-update has now a different meaning - in QGIS <= 2.4 it allowed to keep the legend nodes per layer up to date with changes to the renderer. In
QGIS master (2.6) this is now always true - legend nodes for each layer are synchronized whenever there is a change to the renderer. Auto-update now
means that layer tree used for composer map is synchronized with the layer tree in the main window - if you change the order of layers / groups, the
composer legend will be updated immediately. That also means that the items are read-only with auto-update enabled.

Unfortunately | haven't realized that composer legend used to show just active map layers - not all. | think for 2.6 it is now too late to bring that functionality
back. On the other hand, the "filter by map" functionality should give you more or less the same result now (if not better thanks to hiding symbols that are

not used).

@Alessandro: in e02e7c | have implemented backward compatibility for projects for QGIS <= 2.4 - so you should not need to rebuild your legends
anymore. Most of the settings are preserved now, with the exception of customization of individual symbols (user text, change of order).

Now | believe the only missing thing really is to show in legend by default just layers that are used for composer map rendering (instead of all layers). At this

point | think this bug is not a blocker anymore, thus lowering the priority.

#7 - 2014-10-31 05:55 AM - Juirgen Fischer

- Target version changed from Version 2.6 to Future Release - High Priority

#8 - 2015-02-16 03:53 AM - Harrissou Santanna

Martin Dobias wrote:

The second issue (with layer titles being visible with filtering enabled even if the layer is not visible) is now fixed (4ac94f).

| think empty groups should also be avoided in this case. If none of the layers in the group is shown in the map/legend, this group should be skipped in the

legend list. It's a bit ugly when you get many empty group names in your legend

The auto-update has now a different meaning - in QGIS <= 2.4 it allowed to keep the legend nodes per layer up to date with changes to the

renderer. In QGIS master (2.6) this is now always true - legend nodes for each layer are synchronized whenever there is a change to the renderer.

Auto-update now means that layer tree used for composer map is synchronized with the layer tree in the main window - if you change the order of
layers / groups, the composer legend will be updated immediately. That also means that the items are read-only with auto-update enabled.

Good to know this; I'll stop wondering why | can no more change my legend labels. Such valuable information is not available in the documentation which
says:
http://docs.qgis.org/2.6/en/docs/user_manual/print_composer/print_composer.html

The legend will be updated automatically if checkbox Auto-update is checked. When Auto-update is unchecked this will give you more control over

the legend items. The icons below the legend items list will be activated.

#9 - 2016-06-22 06:28 AM - Jiirgen Fischer
- Assignee deleted (Martin Dobias)

#10 - 2017-03-07 02:14 AM - Giovanni Manghi
- Target version deleted (Future Release - High Priority)

- Priority changed from High to Normal
- Status changed from Open to Feedback

What is the status of this issue in recent QGIS releases?

#11 - 2017-03-08 04:35 AM - Harrissou Santanna
All the points are still valid:
- Auto-update is on by default without filtering the map: when a legend is created, all the layer panel is added
- Groups without any visible layer are shown in the legend (unless you filter by map)
#12 - 2017-03-08 05:05 AM - Giovanni Manghi
Harrissou Santanna wrote:
All the points are still valid:

- Auto-update is on by default without filtering the map: when a legend is created, all the layer panel is added
- Groups without any visible layer are shown in the legend (unless you filter by map)

on 2.18.4 or master or both?

#13 - 2017-03-08 05:31 AM - Harrissou Santanna

Both

#14 - 2017-04-29 06:21 AM - Giovanni Manghi

- Target version set to Version 2.18

- Status changed from Feedback to Open

- Priority changed from Normal to Severe/Regression

- Affected QGIS version changed from master to 2.18.4

#15 - 2017-04-30 05:08 PM - Giovanni Manghi
- Regression? set to Yes

#16 - 2017-04-30 05:08 PM - Giovanni Manghi
- Priority changed from Severe/Regression to High
#17 - 2017-05-01 01:10 AM - Giovanni Manghi

- Easy fix? set to No

#18 - 2018-03-29 04:15 PM - Harrissou Santanna
- Duplicated by Feature request #18579: More intuitive Legend Items when adding legend to layout added

#19 - 2019-03-09 03:09 PM - Giovanni Manghi

- Status changed from Open to Closed

- Resolution set to end of life

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

QGIS 3.4 has recently become our new Long Term Release (LTR) version. This is a major step in our history - a long term release version based on the

massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version
will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the
relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the

ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help

you plan your deployment of QGIS into an operational environment.

The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and
administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and

support the project even more, for the long term improvement and sustainability of the QGIS project.
